'\" Copyright (c) 1996 Sun Microsystems, Inc.
'\"
'\" See the file "license.terms" for information on usage and redistribution
'\" of this file, and for a DISCLAIMER OF ALL WARRANTIES.
'\"
'\" @(#) socket.n 1.4 96/01/17 17:05:29
.so man.macros
.TH socket n 7.5 Tcl "Tcl Built-In Commands"
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
socket \- Open a network connection
.SH SYNOPSIS
.sp
\fBsocket \fR?\fIprotocol\fR? \fIhost port\fR
.sp
\fBsocket \fB\-server \fIcommand\fR ?\fIprotocol\fR? \fIport\fR
.BE

.SH DESCRIPTION
.PP
This command opens a network socket and returns a channel
identifier that may be used in future invocations of commands like
\fBread\fR, \fBputs\fR and \fBflush\fR.
The \fBsocket\fR command may be used to open either the client or
server side of a connection, depending on whether the \fB\-server\fR
switch is specified.
.PP
If \fB\-server\fR is not specified, then the client side of a
connection is opened and the command returns a channel identifier
that can be used for both reading and writing.
\fIPort\fR and \fIhost\fR specify a port
to connect to;  there must be a server accepting connections on
this port.  \fIPort\fR is an integer port number and \fIhost\fR
is either a domain-style name such as \fBnoam.eng.sun.com\fR or
a numerical IP address such as \fB127.0.0.1\fR.
Use \fIlocalhost\fR to refer to the host on which the command is invoked.
If a \fIprotocol\fR option is specified, it indicates which
protocol to use when connecting to the server.
At present, the only valid option for \fIprotocol\fR is \fB\-tcp\fR,
which selects the TCP protocol.
If \fIprotocol\fR is omitted it defaults to \fB\-tcp\fR.
.PP
If the \fB\-server\fR option is specified then this application
becomes a server for the port given by \fIport\fR.
Tcl automatically accepts connections from clients on the given port.
For each connection Tcl creates a new channel that may be used to
communicate with the client.  Tcl then invokes \fIcommand\fR
with two additional arguments: the name of the new channel and the
address, in network address notation, of the client's host.
.PP
Server channels cannot be used for input or output; their sole use is to
accept new client connections. The channels created for each incoming
client connection are opened for input and output. Closing the server
channel shuts down the server so that no new connections will be
accepted;  however, existing connections will be unaffected.

.SH "SEE ALSO"
flush(n), open(n), read(n)

.SH KEYWORDS
channel, connection, domain name, host, network address, socket, tcp
